% Serial Number of the camera to connect to.
zclim = [0 3500];
aclim = [0 255];

kea = tof.KeaCamera(tof.ProcessingConfig(), "202001a");

cap_types = [tof.FrameType.X, tof.FrameType.Y, tof.FrameType.Z, tof.FrameType.INTENSITY];
tof.selectStreams(kea, cap_types);

roi = kea.getCameraConfig().getRoi(0);
nrows = roi.getImgRows();
ncols = roi.getImgCols();

kea.start();

fig = figure();
subplot(121);
imhandle = imagesc(ones(nrows, ncols, 'single'), zclim);
ax1 = gca;
title('Distance');

subplot(122);
imhandle2 = imagesc(ones(nrows, ncols, 'single'), aclim);
ax2 = gca;
title('intensity');

% When we close the window stop the camera, this is crashing, maybe it isnt thread safe?
set(fig, 'CloseRequestFcn', 'kea.stop(); closereq')

while kea.isStreaming()
    frames = kea.getFrames();

    for frame = frames

        if frame.frameType() == tof.FrameType.X
            x = frame.data();
        elseif frame.frameType() == tof.FrameType.Y
            y = frame.data();
        elseif frame.frameType() == tof.FrameType.Z
            z = frame.data();
        elseif frame.frameType() == tof.FrameType.INTENSITY
            i = frame.data();
        end

    end

    % Generate the point cloud points
    xyzPoints = [reshape(x, 1, []); reshape(y, 1, []); reshape(z, 1, [])];
    % if you have correct toolboxs you can use pointCloud() on the
    % xyzPoints.

    set(imhandle, 'CData', rot90(z, 1));
    colormap(ax1, 'jet');

    set(imhandle2, 'CData', rot90(i, 1));
    colormap(ax2, 'gray');
    drawnow;
end
